Subject: Re: linux-next: Tree for Apr 20 (usb & target)

From: Felipe Balbi <[email-masked]>
Date: Fri, 4 May 2012 12:41:43 +0300

Hi,

On Thu, May 03, 2012 at 08:34:23PM -0700, Nicholas A. Bellinger wrote:
> On Sun, 2012-04-22 at 21:01 +0200, Sebastian Andrzej Siewior wrote:
> > * Greg KH | 2012-04-21 08:34:02 [-0700]:
> > 
> > >> > CONFIG_MODULES is not enabled.
> > >> > CONFIG_TCM_USB_GADGET=y
> > >> > CONFIG_USB_GADGET=y
> > >> 
> > >> Sebastian + Greg-KH (Cc'ed), any ideas why this is the case here..?
> > >
> > >I have no idea, sorry.
> > 
> > The short version:
> > in order to fix this either move the usb-target-gadget to
> > drivers/usb/gadget/Kconfig and make sure only one gadget can be compiled
> > at a time or add some kind of depends.
> > 
> > The longer version:
> > This is a short comming of the gadget framework. We are able to build
> > multiple UDCs at a time and we can build multiple gadgets _as_ modules.
> > Since we can not bind & configure via an interface the whole thing works
> > right now via "modprobe $gadget. There is some infrastructure to accept
> > multiple UDCs/gadget but the *whole* thing is not complete.
> > In non-modules mode you can only select one gadget at a time. With the
> > target gadget living outside of usb/gadget selection it is possible to
> > select both at the same time which causes the duplicate symbols here.
> > A "quick" fix is not to define all the functions static and put
> > maybe_unsued on each function to avoid warnings. This is only duct tape
> > on top and I would prefer that nobody is sending such a patch. The
> > result is hardly usefull by a user.
> > A real fix would to get rid of the "#includes foo.c" and use a helper
> > module/library instead.
> > I tried this once and notice that the whole thing relies on
> > static/global variables which are initialized once on modprobe. So
> > with the second module loaded (read as rmmod $mod1 && modprobe $mod2)
> > the gadget framework explodes. Once I noticed that, the patches got out
> > of Felipe's tree before anyone noticed something. That means we should
> > first get rid of the global variables and then maybe try again :)
> > 
> 
> Hey Sebastian & USB folks,
> 
> So I'm catching up on for-next-merge stuff after being away last week,
> and ended up following your advice to just move tcm_usb_gadget code into
> drivers/usb/gadget/ in to address the legacy requirements above..
> 
> After the recommended change, the in-kernel config using a single gadget
> driver (the target) are able to build.  Thanks for the detailed
> explanation btw.. ;)
> 
> I've made the same change for tcm_usb_gadget in lio-core, and updated
> for-next-merge with the following merge patch:
> 
> http://git.kernel.org/?p=linux/kernel/git/nab/target-pending.git;a=commit;h=0c41520201bc0933d65b8644173802778f426234
> 
> Please let me know if you have any other changes that should go into
> sunday's linux-next build.

It looks ok to me. You can add my Acked-by: Felipe Balbi <[email-masked]>

-- 
balbi